org.apache.solr.search

## Interface SolrCache<K,V>

- All Superinterfaces:
    SolrInfoMBean
  All Known Implementing Classes:
    FastLRUCache, LFUCache, LRUCache

      public interface SolrCache<K,V>
      extends SolrInfoMBean

  Primary API for dealing with Solr's internal caches.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `SolrCache.State` Enumeration of possible States for cache instances.

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` :TODO: copy from Map
    `void` | `close()` Frees any non-memory resources
    `V` | `get(K key)` :TODO: copy from Map
    `SolrCache.State` | `getState()` Returns the last State set on this instance
    `Object` | `init(Map args, Object persistence, CacheRegenerator regenerator)` The initialization routine.
    `String` | `name()` Name the Cache can be referenced with by SolrRequestHandlers.
    `V` | `put(K key, V value)` :TODO: copy from Map
    `void` | `setState(SolrCache.State state)` Set different cache states.
    `int` | `size()` :TODO: copy from Map
    `void` | `warm(SolrIndexSearcher searcher, SolrCache<K,V> old)` Warm this cache associated with `searcher` using the `old` cache object.

    - ### Methods inherited from interface org.apache.solr.core.SolrInfoMBean

      `getCategory, getDescription, getDocs, getName, getSource, getStatistics, getVersion`

- - ### Method Detail

    - #### init

          Object init(Map args,
                      Object persistence,
                      CacheRegenerator regenerator)

      The initialization routine. Instance specific arguments are passed in the `args` map.

      The persistence object will exist across different lifetimes of similar caches. For example, all filter caches will share the same persistence object, sometimes at the same time (it must be thread-safe). If null is passed, then the cache implementation should create and return a new persistence object. If not null, the passed in object should be returned again.

      Since it will exist across the lifetime of many caches, care should be taken to not reference any particular cache instance and prevent it from being garbage collected (no using inner classes unless they are static).

      The persistence object is designed to be used as a way for statistics to accumulate across all instances of the same type of cache, however the object may be of any type desired by the cache implementation.

      The `CacheRegenerator` is what the cache uses during auto-warming to regenerate an item in the new cache from an entry in the old cache.

    - #### name

          String name()

      Name the Cache can be referenced with by SolrRequestHandlers. This method must return the identifier that the Cache instance expects SolrRequestHandlers to use when requesting access to it from the SolrIndexSearcher. It is strongly recommended that this method return the value of the "name" parameter from the init args. :TODO: verify this.

    - #### size

          int size()

      :TODO: copy from Map

    - #### put

          V put(K key,
                V value)

      :TODO: copy from Map

    - #### get

          V get(K key)

      :TODO: copy from Map

    - #### clear

          void clear()

      :TODO: copy from Map

    - #### setState

          void setState(SolrCache.State state)

      Set different cache states. The state a cache is in can have an effect on how statistics are kept. The cache user (SolrIndexSearcher) will take care of switching cache states.

    - #### getState

          SolrCache.State getState()

      Returns the last State set on this instance
      See Also:
        `setState(org.apache.solr.search.SolrCache.State)`

    - #### warm

          void warm(SolrIndexSearcher searcher,
                    SolrCache<K,V> old)

      Warm this cache associated with `searcher` using the `old` cache object. `this` and `old` will have the same concrete type.

    - #### close

          void close()

      Frees any non-memory resources

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.